Ext.namespace('dSS', 'dSS.util');

dSS.util.UpdateRowSpan = function(scope, onlyfirst) {
    var columns = scope.getColumnModel().config;
    var view = scope.getView();
    var store = scope.getStore();
    var rowCount = store.getCount();
        
    var column = columns[0];
    var dataIndex = column.dataIndex;
       
    var column2 = columns[1];
    var dataIndex2 = column2.dataIndex;

    var spanCell = null;
    var spanCount = null;
    var spanValue = null;

    var spanCell2 = null;
    var spanCount2 = null;
    var spanValue2 = null;

    for (var row = 0; row < rowCount; ++row) {
        var cell = view.getCell(row, 0);
        var cell2 = view.getCell(row, 1);
        var record = store.getAt(row);
        var value = record.get(dataIndex);
        var value2 = record.get(dataIndex2);
        
        if (spanValue != value) {
            if (spanCell !== null) {
                spanCell.rowSpan = spanCount;
            }
            
            var c = Ext.fly(cell);
            c.setStyle('display', '');

            spanCell = cell;
            spanCount = 1;
            spanValue = value;
        } else {
            spanCount++;
            var c = Ext.fly(cell);
            c.update('');
            var d = c.findParent('div', 5, true);
            if (d) {
                d.addClass('grid-cell-no-borders');
            }
        }

        if (!onlyfirst) {
            if (spanValue2 != value2) {
                if (spanCell2 !== null) {
                    spanCell2.rowSpan = spanCount2;
                }
            
                var c = Ext.fly(cell2);
                c.setStyle('display', '');
                if (spanCount > 1) {
                    c.addClass('grid-top-border');
                    var cell3 = view.getCell(row, 2);
                    Ext.fly(cell3).addClass('grid-top-border');
                }

                spanCell2 = cell2;
                spanCount2 = 1;
                spanValue2 = value2;
            } else {
                spanCount2++;
                var c = Ext.fly(cell2);
                c.update('');
            }
        }
    }
    
    if (spanCell !== null) {
        spanCell.rowSpan = spanCount;
    }

    if (!onlyfirst) {
        if (spanCell2 !== null) {
            spanCell2.rowSpan = spanCount2;
        }
    }
}

dSS.SystemStateTable = Ext.extend(Ext.grid.GridPanel, {
    initComponent: function() {
        var store = new Ext.data.ArrayStore({
            autoDestroy: true,
            hasMultiSort: true,
            multiSortInfo:
            {
                direction: 'ASC',
                sorters:
                [ 
                    { field: 'typesummary', direction: 'ASC' },
                    { field: 'type', direction: 'ASC' }
                ]
            },
            fields: [ 'typesummary', 'type', 'state' ]
        });

        Ext.apply(this, {
            title: dSS._("System State"),
            store: store,
            viewConfig:
            {
                hideSortIcons: true,
                stripeRows: false,
                rowOverCls: ''
            },
            cls: 'grid-no-borders',
            columnLines: true,
            enableColumnHide: false,
            enableColumnMove: false,
            minColumnWidth: 80,
            enableHdMenu: false,
            columns:
            [
                {
                    header: dSS._("Type"),
                    tooltip: dSS._("Type"),
                    dataIndex: 'typesummary',
                    sortable: false,
                    width: 200
                },
                {
                    dataIndex: 'type',
                    sortable: false,
                    width: 120
                },
                {
                    header: dSS._("State"),
                    tooltip: dSS._("State"),
                    sortable: false,
                    dataIndex: 'state',
                    width: 180
                }
            ]
        });

        dSS.SystemStateTable.superclass.initComponent.apply(this, arguments);

        this.on('afterrender', function() {
            this.getSelectionModel().clearSelections(true);
            this.getSelectionModel().lock();
        }, this);

        this.getView().on('refresh', this.updateRowSpan, this);
    },
    updateRowSpan: function() {
        dSS.util.UpdateRowSpan(this, false);
    }
});
Ext.reg ('dsssysstatetable', dSS.SystemStateTable);

dSS.ZoneStateTable = Ext.extend(Ext.grid.GridPanel, {
    initComponent: function() {
        var store = new Ext.data.JsonStore({
            autoDestroy: true,
            sortInfo: { field: 'zone', direction: 'ASC' },
            root: 'data',
            fields: 
            [
                'zone',
                'Light',
                'Shadow',
                'Heating',
                'Audio',
                'Video',
                'sensors',
                'tempcontrol'
            ]
        });

        Ext.apply(this, {
            title: dSS._("Room State"),
            stripeRows: false,
            columnLines: true,
            viewConfig:
            {
                hideSortIcons: true,
                stripeRows: false,
                rowOverCls: ''
            },
            cls: 'grid-no-borders',
            enableColumnHide: false,
            enableColumnMove: false,
            enableHdMenu: false,
            store: store,
            columns:
            [
                {
                    header: dSS._("Room"),
                    tooltip: dSS._("Room"),
                    dataIndex: 'zone',
                    sortable: false
                },
                {
                    header: dSS._("Light"),
                    tooltip: dSS._("Light"),
                    dataIndex: 'Light',
                    sortable: false
                },
                {
                    header: dSS._("Shade"),
                    tooltip: dSS._("Shade"),
                    dataIndex: 'Shadow',
                    sortable: false
                },
                {
                    header: dSS._("Heating"),
                    tooltip: dSS._("Heating"),
                    dataIndex: 'Heating',
                    sortable: false
                },
                {
                    header: dSS._("Audio"),
                    tooltip: dSS._("Audio"),
                    dataIndex: 'Audio',
                    sortable: false
                },
                {
                    header: dSS._("Video"),
                    tooltip: dSS._("Video"),
                    dataIndex: 'Video',
                    sortable: false
                },
                {
                    header: dSS._("Temperature control"),
                    tooltip: dSS._("Temperature control"),
                    dataIndex: 'tempcontrol',
                    sortable: false
                },
                {
                    header: dSS._("Sensor values"),
                    tooltip: dSS._("Sensor values"),
                    dataIndex: 'sensors',
                    sortable: false
                }
            ]
        });

        dSS.ZoneStateTable.superclass.initComponent.apply(this, arguments);

        this.on('afterrender', function() {
            this.getSelectionModel().clearSelections(true);
            this.getSelectionModel().lock();
        }, this);

        this.getView().on('refresh', this.updateRowSpan, this);
    },
    updateRowSpan: function() {
        dSS.util.UpdateRowSpan(this, true);
    }
});
Ext.reg ('dsszonestatetable', dSS.ZoneStateTable);

dSS.GroupStateTable = Ext.extend(Ext.grid.GridPanel, {
    initComponent: function() {
        var store = new Ext.data.ArrayStore({
            fields: [ 'group', 'color', 'state', 'conflock', 'oplock' ]
        });

        Ext.apply(this, {
            title: dSS._("Group State"),
            viewConfig:
            {
                hideSortIcons: true,
                stripeRows: false,
                rowOverCls: ''
            },
            store: store,
            columns:
            [
                {
                    header: dSS._("Group"),
                    tooltip: dSS._("Group"),
                    dataIndex: 'group',
                    sortable: false
                },
                {
                    header: dSS._("Color group"),
                    tooltip: dSS._("Color group"),
                    dataIndex: 'color',
                    sortable: false
                },
                {
                    header: dSS._("State"),
                    tooltip: dSS._("State"),
                    dataIndex: 'state',
                    sortable: false
                },
                {
                    header: dSS._("Configuration"),
                    tooltip: dSS._("Configuration"),
                    dataIndex: 'conflock',
                    sortable: false
                },
                {
                    header: dSS._("Operation lock"),
                    tooltip: dSS._("Operation lock"),
                    datIndex: 'oplock',
                    sortable: false
                }
            ]
        });

        dSS.GroupStateTable.superclass.initComponent.apply(this, arguments);

        this.on('afterrender', function() {
            this.getSelectionModel().clearSelections(true);
            this.getSelectionModel().lock();
        }, this);
    }
});
Ext.reg ('dssgroupstatetable', dSS.GroupStateTable);


dSS.SystemStatesPanel = Ext.extend(Ext.Panel, {
    constructor: function(config) {
        if (config && config.sizeObject) {
            this.sizeObject = config.sizeObject;
        }

        this.heightConfigured = false;

        Ext.apply(this, {
            title: dSS._("System states"),
            layout: 'border',
            items:
            [
                {
                    xtype: 'dsssysstatetable',
                    ref: 'systemstates',
                    split: true,
                    region: 'north'
                },
                {
                    xtype: 'dsszonestatetable',
                    ref: 'zonestates',
                    split: true,
                    region: 'center'
                },
                {
                    xtype: 'dssgroupstatetable',
                    ref: 'groupstates',
                    split: true,
                    region: 'south'
                }
            ]
        });

        dSS.SystemStatesPanel.superclass.constructor.apply(this, arguments);

        this.on('activate', function() {
            this.maskEl.mask(dSS._("Loading") + "...", 'x-mask-loading');
            this.requestData()
        }, this)


        dSS.MessageBus.on('refreshview', function() {
            if (this.isVisible()) {
                dSS.MessageBus.on('structureloaded',
                                  this.requestData.createDelegate(this),
                                  this, { single: true });
                this.maskEl.mask(dSS._("Loading") + "...", 'x-mask-loading');
                dSS.MessageBus.fireEvent('reloadapartment');
            }
        }, this);

        this.on('afterrender', function() {
            this.maskEl = this.findParentByType(Ext.Viewport).el;

            if (!this.heightConfigured) {
                if (!this.sizeObject) {
                    this.sizeObject = this.ownerCt;
                }

                if (this.sizeObject) {
                    var h = this.sizeObject.getInnerHeight() / 3;
                    this.systemstates.setHeight(h);
                    this.zonestates.setHeight(h);
                    this.groupstates.setHeight(h);
                    this.heightConfigured = true;
                }
            }
        }, this);
    },
    requestGroupData: function(oplocks) {
        Ext.Ajax.request(
        {
            url: '/json/property/query',
            method: 'GET',
            scope: this,
            params:
            {
                query: "/apartment/zones/zone0/groups/*(group,lastCalledScene,name,ConfigurationLocked,color)"
            },
            success: function(result) {
                try {
                    var json = Ext.util.JSON.decode(result.responseText);
                    if (!json.ok) {
                        Ext.Msg.alert(dSS._("Error"),
                            dSS._("Could not load state information from dSS") +
                            ': ' + json.message);
                        this.maskEl.unmask();
                        return;
                    }
                    var groupdata = [];
                    var groupStore = dSS.data.Loader.getGroupStore();

                    var i;
                    for (i = 0; i < json.result.groups.length; i++) {
                        var group = json.result.groups[i];
                        if ((group.group < 16) || (group.group > 47) ||
                            (group.color === 0)) {
                            continue;
                        }

                        var name = "";
                        var grouprec = groupStore.getById(group.group);
                        if (grouprec) {
                            name = grouprec.get('name');
                        }

                        if (name.length === 0) {
                            name = dSS._("Group") + " #" + group.group;
                        }

                        var lock = "not locked";
                        if (group.ConfigurationLocked === true) {
                            lock = "locked";
                        }

                        var oplock = "not locked";
                        if (oplocks[group.group] === true) {
                            oplock = "locked";
                        }
                        groupdata.push(
                        [
                            name,
                            dSS._(dSS.config.groupNames[group.color]),
                            dSS._(dSS.util.SceneToString(group.lastCalledScene)),
                            dSS._(lock),
                            dSS._(oplock)
                        ]);
                    }

                    this.groupstates.getStore().loadData(groupdata);
                    this.maskEl.unmask();
                } catch (err) {
                    Ext.Msg.alert(dSS._("Error"),
                        dSS._("Could not load state information from dSS") +
                              ": " + err); 
                    this.maskEl.unmask();
                }
            },
            failure: function(result) {
                Ext.Msg.alert(dSS._("Error"),
                    dSS._("Could not load state information from dSS"));
                this.maskEl.unmask();
            }
        });


    },
    requestData: function() {
        this.maskEl.mask(dSS._("Loading") + "...", 'x-mask-loading');
        var initZone = function() {
            return {
                       zone:    "",
                       Light:   "",
                       Shadow:  "",
                       Heating: "",
                       Audio:   "",
                       Video:   "",
                       sensors: "",
                       tempcontrol: ""
                   };
        };

        var oplocks = {};

        var zoneStore = dSS.data.Loader.getZoneStore();
        var groupStore = dSS.data.Loader.getGroupStore();

        var getSensors = function(sensors, addtype) {
            var ret = "";
            if (sensors === undefined) {
                return ret;
            }

            var s;
            for (s = 0; s < sensors.length; s++) {
                var sensor = sensors[s];
                if (!dSS.util.isVisibleSensorType(sensor.type, true) &&
                    ((sensor.type !== dSS.config.SensorTypes.ROOM_TEMP_SETPOINT)) &&
                     (sensor.type !== dSS.config.SensorTypes.ROOM_TEMP_CONTROL_VAR)) {
                    continue;
                }

                var unit = dSS._(dSS.config.SensorTypeUnits[sensor.type]);
                var type = dSS._(dSS.config.SensorTypeStrings[sensor.type]);
                if (sensor.type === dSS.config.SensorTypes.ROOM_TEMP_SETPOINT) {
                    type = dSS._("Set temperature");
                } else if (sensor.type === dSS.config.SensorTypes.ROOM_TEMP_CONTROL_VAR) {
                    type = dSS._("Control value")
                }

                if (ret.length > 0) {
                    ret = ret + "<br>";
                }
                var value = String(Math.round(sensor.value * 10) / 10);
                if (addtype === true) {
                    ret = ret + type + ": " + value;
                } else {
                    ret = ret + value + " " + unit;
                }
            }

            return ret;
        };

        Ext.Ajax.request(
        {
            url: '/json/property/query',
            method: 'GET',
            scope: this,
            params:
            {
                query: '/usr/states/*(name,value,state)'
            },
            success: function(result) {
                try {
                    var json = Ext.util.JSON.decode(result.responseText);
                    if (!json.ok) {
                        Ext.Msg.alert(dSS._("Error"),
                            dSS._("Could not load state information from dSS") +
                            ': ' + json.message);
                        this.maskEl.unmask();
                        return;
                    }

                    var system = [];
                    var zones = {};
                    var zoneStore = dSS.data.Loader.getZoneStore();
                    var i;
                    for (i = 0; i < json.result.states.length; i++) {
                        var state = json.result.states[i];
                        if (state.name === "holiday") {
                            var value = dSS._("active");
                            if (state.value === "off") {
                                value = dSS._("inactive");
                            }
                            system.push([ dSS._("Presence simulation"),
                                          "", value ]);
                        } else if (state.name === "presence") {
                            var value = "Present";
                            if (state.state !== "present") {
                                value = "Absent";
                            }
                            system.push([ dSS._("Presence in system state table"), "",
                                          dSS._(value) ]);
                        } else if ((state.name === "wind") || 
                                   (state.name === "rain") ||
                                   (state.name === "hail") ||
                                   (state.name === "frost")) {
                            var value = state.name;
                            if (state.state === "inactive") {
                                value = "No " + state.name;
                            }
                            system.push([ dSS._("Weather"),
                                          dSS._(state.name), dSS._(value) ]);
                        } else if ((state.name === "fire") ||
                                   (state.name === "panic")) {
                            var value = state.name;
                            if (state.state === "inactive") {
                                value = "No " + state.name;
                            }
                            system.push([ dSS._("Security"),
                                          dSS._(state.name), dSS._(value) ]);
                        } else if (state.name === "alarm") {
                            var value = "Alarm 1 active";
                            if (state.state === "inactive") {
                                value = "Alarm 1 inactive";
                            }
                            system.push([ dSS._("Security"),
                                          dSS._("Alarm"), dSS._(value) ]);
                        } else if (state.name === "alarm2") {
                            var value = "Alarm 2 active";
                            if (state.state === "inactive") {
                                value = "Alarm 2 inactive";
                            }
                            system.push([ dSS._("Security"),
                                          dSS._("Alarm"), dSS._(value) ]);
                        } else if (state.name === "alarm3") {
                            var value = "Alarm 3 active";
                            if (state.state === "inactive") {
                                value = "Alarm 3 inactive";
                            }
                            system.push([ dSS._("Security"),
                                          dSS._("Alarm"), dSS._(value) ]);
                        } else if (state.name === "alarm4") {
                            var value = "Alarm 4 active";
                            if (state.state === "inactive") {
                                value = "Alarm 4 inactive";
                            }
                            system.push([ dSS._("Security"),
                                          dSS._("Alarm"), dSS._(value) ]);
                        } else if (state.name === "daylight") {
                            var value = "Bright";
                            if (state.value === false) {
                                value = "Dark";
                            }
                            system.push([ dSS._("Solar altitude"), "",
                                          dSS._(value) ]);
                        } else if (state.name === "daynight") {
                            var value = "Daytime";
                            if (state.value === false) {
                                value = "Nighttime";
                            }
                            system.push([ dSS._("Solar altitude"), "",
                                          dSS._(value) ]);
                        } else if (state.name === "twilight") {
                            if (state.value === true) {
                                system.push([ dSS._("Solar altitude"), "",
                                              dSS._("Twilight") ]);
                            }
                        } else if (state.name.lastIndexOf("zone", 0) === 0) {
                            var parts = state.name.split('.');
                            if (parts.length === 3) {
                                var zone_id = parts[1];
                                var type = parts[2];

                                if (state.state !== "unknown") {
                                    var zone = zoneStore.getById(zone_id);

                                    if (type === "light") {
                                        var value = "Light is on";
                                        if (state.state === "inactive") {
                                            value = "Light is off";
                                        }
                                        if (zone) {
                                            if (zones[zone_id] === undefined) {
                                                zones[zone_id] = initZone();
                                            }
                                            zones[zone_id].zone = zone.get('name');
                                            zones[zone_id].Light = dSS._(value);
                                        }
                                    } else if (type === "motion") {
                                        var value = "Motion";
                                        if (state.state === "inactive") {
                                            value = "No motion";
                                        }
                                        if (zone) {
                                            if (zones[zone_id] === undefined) {
                                                zones[zone_id] = initZone();
                                            }
                                            zones[zone_id].zone = zone.get('name');
                                            if (zones[zone_id].sensors.length > 0) {
                                                zones[zone_id].sensors = zones[zone_id].sensors + dSS._(value);
                                            } else {
                                                zones[zone_id].sensors = dSS._(value);
                                            }
                                        }
                                    } else if (type === "presence") {
                                        // show presence state only when active
                                        if (state.state === "active") {
                                            if (zone) {
                                                if (zones[zone_id] === undefined) {
                                                    zones[zone_id] = initZone();
                                                }
                                                zones[zone_id].zone = zone.get('name');
                                                if (zones[zone_id].sensors.length > 0) {
                                                    zones[zone_id].sensors = zones[zone_id].sensors + "<br>" + dSS._("Present");
                                                } else {
                                                    zones[zone_id].sensors = dSS._("Present");
                                                }
                                            }
                                        }
                                    }
                                } 
                            }
                        } else if (state.name.lastIndexOf("wind.group", 0) === 0) {
                            var parts = state.name.split('.');
                            if (parts.length === 2) {
                                var groupId = parts[1].substr("group".length);
                                var group = groupStore.getById(groupId);

                                var value = "No wind in %1";
                                if (state.active) {
                                    value = "Wind in %1";
                                }
                                if (group) {
                                    var name = group.get('name');
                                    system.push(
                                    [ 
                                        dSS._("Weather"),
                                        dSS._("wind"),
                                        dSS.gt.strargs(dSS._(value),
                                                       [ group.get('name') ])
                                    ]);

                                }
                            }
                        } else if (state.name.lastIndexOf("cluster", 0) === 0) {
                            var parts = state.name.split('.');
                            if (parts.length === 3) {
                                var groupId = parts[1];
                                var type = parts[2];
                                if (type === "operation_lock") {
                                    if (state.state === "active") {
                                        oplocks[groupId] = true;
                                    }
                                }
                            }
                        }
                    }
   
                    this.systemstates.getStore().loadData(system);

                    Ext.Ajax.request(
                    {
                        url: '/json/property/query',
                        method: 'GET',
                        scope: this,
                        params:
                        {
                            query: '/apartment/zones/*(ZoneID,name)/groups/*(group,lastCalledScene)/sensor/*(value,type)'
                        },
                        success: function(result) {
                            try {
                                var json = Ext.util.JSON.decode(result.responseText);
                                if (!json.ok) {
                                    Ext.Msg.alert(dSS._("Error"),
                                        dSS._("Could not load state information from dSS") +
                                        ': ' + json.message);
                                    this.maskEl.unmask();
                                    return;
                                }

                                var z;
                                for (z = 0; z < json.result.zones.length; z++) {
                                    var lz = json.result.zones[z];
                                    if (lz.ZoneID === 0) {
                                        continue;
                                    }

                                    var g;
                                    for (g = 0; g < lz.groups.length; g++) {
                                        var grp = lz.groups[g];
                                        switch (grp.group)
                                        {
                                            case dSS.config.groups.LIGHT:
                                            case dSS.config.groups.SHADOW:
                                            case dSS.config.groups.HEATING:
                                            case dSS.config.groups.AUDIO:
                                            case dSS.config.groups.VIDEO:
                                            {
                                                var zone = zoneStore.getById(
                                                                    lz.ZoneID);
                                                if (zone) {
                                                    if (zones[lz.ZoneID] 
                                                                === undefined) {
                                                        zones[lz.ZoneID] =
                                                                    initZone();
                                                    }
                                                    zones[lz.ZoneID].zone = zone.get('name');
                                                    var lf = "";
                                                    if (zones[lz.ZoneID][dSS.config.groupNames[grp.group]].length > 0) {
                                                        lf = "<br>";
                                                    }
                                                    zones[lz.ZoneID][dSS.config.groupNames[grp.group]] = zones[lz.ZoneID][dSS.config.groupNames[grp.group]] + lf + dSS._(dSS.util.SceneToString(grp.lastCalledScene));
                                                }

                                                break;
                                            }
                                            case dSS.config.groups.VARIABLE:
                                            {
                                                var sens =
                                                    getSensors(grp.sensor);
                                                var zone = zoneStore.getById(
                                                                     lz.ZoneID);
                                                if (zone) {
                                                    if (zones[lz.ZoneID]
                                                            === undefined) {
                                                        zones[lz.ZoneID] =
                                                                initZone();
                                                    }
                                                    zones[lz.ZoneID].zone =
                                                        zone.get('name');
                                                    if (zones[lz.ZoneID].sensors.length > 0) {
                                                        zones[lz.ZoneID].sensors = zones[lz.ZoneID].sensors + "<br>" + sens;
                                                    } else {
                                                        zones[lz.ZoneID].sensors = sens;
                                                    }
                                                }
                                                break;
                                            }
                                            case dSS.config.groups.TEMPCONTROL:
                                            {
                                                var str =
                                                    getSensors(grp.sensor, true);
 
                                                if ((grp.lastCalledScene >= 0) &&
                                                    (grp.lastCalledScene <= 5)) {
                                                    var mode = dSS._(dSS.config.TempControlSceneNames[grp.lastCalledScene]);
                                                    if (str.length > 0) {
                                                        str = str + "<br>" + mode;
                                                    } else {
                                                        str = mode;
                                                    }
                                                }

                                                var zone = zoneStore.getById(
                                                                     lz.ZoneID);
                                                if (zone) {
                                                    if (zones[lz.ZoneID]
                                                            === undefined) {
                                                        zones[lz.ZoneID] =
                                                                initZone();
                                                    }
                                                    zones[lz.ZoneID].zone =
                                                        zone.get('name');
                                                    if (str.length > 0) {
                                                        if (zones[lz.ZoneID].tempcontrol.length > 0) {
                                                            zones[lz.ZoneID].tempcontrol = zones[lz.ZoneID].tempcontrol + "<br>" + str;
                                                        } else {
                                                            zones[lz.ZoneID].tempcontrol = str;
                                                        }
                                                    }
                                                }
                                                break;
                                            }
                                            default:
                                                break;
                                        }
                                    }
                                }
                                var load = [];
                                for (var property in zones) {
                                    if (zones.hasOwnProperty(property)) {
                                        load.push(zones[property]);
                                    }
                                }
                                this.zonestates.getStore().loadData({ data: load });
                                this.requestGroupData(oplocks);
                            } catch (err) {
                                Ext.Msg.alert(dSS._("Error"),
                                    dSS._("Could not load state information from dSS") +
                                          ": " + err); 
                                this.maskEl.unmask();
                            }
                        },
                        failure: function(result) {
                            Ext.Msg.alert(dSS._("Error"),
                                dSS._("Could not load state information from dSS"));
                            this.maskEl.unmask();
                        }
                    });
                } catch (err) {
                    Ext.Msg.alert(dSS._("Error"),
                        dSS._("Could not load state information from dSS") +
                              ": " + err); 
                    this.maskEl.unmask();
                }
            },
            failure: function(result) {
                Ext.Msg.alert(dSS._("Error"),
                    dSS._("Could not load state information from dSS"));
                this.maskEl.unmask();
            }
        });
    }
});

Ext.reg('dsssystemstates', dSS.SystemStatesPanel);
